Wt: Wt::WFileDropWidget::File Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Wt::WFileDropWidget::File Class Reference

A nested class of WFileDropWidget representing a file. More...

`#include <WFileDropWidget.h>`

Inheritance diagram for Wt::WFileDropWidget::File:
[legend]

## Public Member Functions
const std::string & | clientFileName () const
| Returns the client filename.
const std::string & | mimeType () const
| Returns the mime-type of the file.
::uint64_t | size () const
| Returns the size of the file.
const Http::UploadedFile & | uploadedFile () const
| Returns the uploaded file as a Http::UploadedFile.
bool | uploadFinished () const
| Returns true if the upload is finished.
Signal< ::uint64_t, ::uint64_t > & | dataReceived ()
| This signal allows you to track the upload progress of the file.
Signal & | uploaded ()
| This signal is triggered when the upload is finished.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual const std::string | id () const
| Returns the (unique) identifier for this object.
virtual void | setObjectName (const std::string &name)
| Sets an object name.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WObject
Protected Member Functions inherited from Wt::WObject
virtual WStatelessSlot * | getStateless (Method method)
| On-demand stateless slot implementation.

## Detailed Description

A nested class of WFileDropWidget representing a file.

The methods returning the filename, mime-type and size return valid values if the upload of this file is not yet finished. The method uploadedFile() is only available after the upload is finished.

## Member Function Documentation

## ◆ dataReceived()

Signal< ::uint64_t, ::uint64_t > & Wt::WFileDropWidget::File::dataReceived | ( |  | ) |

This signal allows you to track the upload progress of the file.

The first argument is the number of bytes received so far, and the second argument is the total number of bytes.

## ◆ uploaded()

Signal & Wt::WFileDropWidget::File::uploaded | ( |  | ) |

This signal is triggered when the upload is finished.

This is also signalled using the WFileDropWidget uploaded() signal.

## ◆ uploadedFile()

const Http::UploadedFile & Wt::WFileDropWidget::File::uploadedFile | ( |  | ) | const

Returns the uploaded file as a Http::UploadedFile.

This method will throw an expection if the upload is not yet finished.

See also
  uploadFinished()

## ◆ uploadFinished()

bool Wt::WFileDropWidget::File::uploadFinished | ( |  | ) | const

Returns true if the upload is finished.

When this method returns true, the uploaded file is available on the server.

See also
  uploadedFile()